diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ctrl-headers.cc ns-3.45/src/wifi/model/ctrl-headers.cc
--- ns-3.44/src/wifi/model/ctrl-headers.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/ctrl-headers.cc	2025-06-01 20:34:45.612702100 -0700
@@ -1187,7 +1187,7 @@
       m_ulFecCodingType(false),
       m_ulMcs(0),
       m_ulDcm(false),
-      m_ps160(true),
+      m_ps160(false),
       m_ulTargetRssi(0),
       m_triggerType(triggerType),
       m_basicTriggerDependentUserInfo(0)
@@ -1391,6 +1391,9 @@
 void
 CtrlTriggerUserInfoField::SetAid12(uint16_t aid)
 {
+    NS_ASSERT_MSG((m_variant == TriggerFrameVariant::HE) || (aid != AID_SPECIAL_USER),
+                  std::to_string(AID_SPECIAL_USER)
+                      << " is reserved for Special User Info Field in EHT variant");
     m_aid12 = aid & 0x0fff;
 }
 
@@ -1413,95 +1416,116 @@
 }
 
 void
-CtrlTriggerUserInfoField::SetRuAllocation(HeRu::RuSpec ru)
+CtrlTriggerUserInfoField::SetRuAllocation(WifiRu::RuSpec ru)
 {
-    NS_ABORT_MSG_IF(ru.GetIndex() == 0, "Valid indices start at 1");
+    const auto ruIndex = WifiRu::GetIndex(ru);
+    const auto ruType = WifiRu::GetRuType(ru);
+    NS_ABORT_MSG_IF(ruIndex == 0, "Valid indices start at 1");
     NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
                     "SetMuRtsRuAllocation() must be used for MU-RTS");
 
-    switch (ru.GetRuType())
+    switch (ruType)
     {
-    case HeRu::RU_26_TONE:
-        m_ruAllocation = ru.GetIndex() - 1;
+    case RuType::RU_26_TONE:
+        m_ruAllocation = ruIndex - 1;
+        NS_ABORT_MSG_IF(!WifiRu::IsHe(ru) && (m_ruAllocation == 18), "Reserved value.");
+        NS_ASSERT(m_ruAllocation <= 36);
         break;
-    case HeRu::RU_52_TONE:
-        m_ruAllocation = ru.GetIndex() + 36;
+    case RuType::RU_52_TONE:
+        m_ruAllocation = ruIndex + 36;
+        NS_ASSERT(m_ruAllocation <= 52);
         break;
-    case HeRu::RU_106_TONE:
-        m_ruAllocation = ru.GetIndex() + 52;
+    case RuType::RU_106_TONE:
+        m_ruAllocation = ruIndex + 52;
+        NS_ASSERT(m_ruAllocation <= 60);
         break;
-    case HeRu::RU_242_TONE:
-        m_ruAllocation = ru.GetIndex() + 60;
+    case RuType::RU_242_TONE:
+        m_ruAllocation = ruIndex + 60;
+        NS_ASSERT(m_ruAllocation <= 64);
         break;
-    case HeRu::RU_484_TONE:
-        m_ruAllocation = ru.GetIndex() + 64;
+    case RuType::RU_484_TONE:
+        m_ruAllocation = ruIndex + 64;
+        NS_ASSERT(m_ruAllocation <= 67);
         break;
-    case HeRu::RU_996_TONE:
+    case RuType::RU_996_TONE:
         m_ruAllocation = 67;
         break;
-    case HeRu::RU_2x996_TONE:
+    case RuType::RU_2x996_TONE:
         m_ruAllocation = 68;
         break;
+    case RuType::RU_4x996_TONE:
+        m_ruAllocation = 69;
+        break;
     default:
         NS_FATAL_ERROR("RU type unknown.");
         break;
     }
 
-    NS_ABORT_MSG_IF(m_ruAllocation > 68, "Reserved value.");
+    NS_ABORT_MSG_IF(m_ruAllocation > 69, "Reserved value.");
+
+    auto b0 = (WifiRu::IsHe(ru) && !std::get<HeRu::RuSpec>(ru).GetPrimary80MHz()) ||
+              (WifiRu::IsEht(ru) && !std::get<EhtRu::RuSpec>(ru).GetPrimary80MHzOrLower80MHz());
+    m_ps160 = (WifiRu::IsEht(ru) && !std::get<EhtRu::RuSpec>(ru).GetPrimary160MHz());
 
     m_ruAllocation <<= 1;
-    if (!ru.GetPrimary80MHz())
+    if (b0)
     {
         m_ruAllocation++;
     }
 }
 
-HeRu::RuSpec
+WifiRu::RuSpec
 CtrlTriggerUserInfoField::GetRuAllocation() const
 {
     NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
                     "GetMuRtsRuAllocation() must be used for MU-RTS");
 
-    HeRu::RuType ruType;
+    RuType ruType;
     std::size_t index;
 
-    bool primary80MHz = ((m_ruAllocation & 0x01) == 0);
+    const auto primaryOrLower80MHz = ((m_ruAllocation & 0x01) == 0);
 
     uint8_t val = m_ruAllocation >> 1;
 
     if (val < 37)
     {
-        ruType = HeRu::RU_26_TONE;
+        ruType = RuType::RU_26_TONE;
         index = val + 1;
     }
     else if (val < 53)
     {
-        ruType = HeRu::RU_52_TONE;
+        ruType = RuType::RU_52_TONE;
         index = val - 36;
     }
     else if (val < 61)
     {
-        ruType = HeRu::RU_106_TONE;
+        ruType = RuType::RU_106_TONE;
         index = val - 52;
     }
     else if (val < 65)
     {
-        ruType = HeRu::RU_242_TONE;
+        ruType = RuType::RU_242_TONE;
         index = val - 60;
     }
     else if (val < 67)
     {
-        ruType = HeRu::RU_484_TONE;
+        ruType = RuType::RU_484_TONE;
         index = val - 64;
     }
     else if (val == 67)
     {
-        ruType = HeRu::RU_996_TONE;
+        ruType = RuType::RU_996_TONE;
         index = 1;
     }
     else if (val == 68)
     {
-        ruType = HeRu::RU_2x996_TONE;
+        ruType = RuType::RU_2x996_TONE;
+        index = 1;
+    }
+    else if (val == 69)
+    {
+        NS_ASSERT(m_variant == TriggerFrameVariant::EHT);
+        ruType = RuType::RU_4x996_TONE;
         index = 1;
     }
     else
@@ -1509,7 +1533,12 @@
         NS_FATAL_ERROR("Reserved value.");
     }
 
-    return HeRu::RuSpec(ruType, index, primary80MHz);
+    if (m_variant == TriggerFrameVariant::EHT)
+    {
+        return EhtRu::RuSpec{ruType, index, !m_ps160, primaryOrLower80MHz};
+    }
+
+    return HeRu::RuSpec{ruType, index, primaryOrLower80MHz};
 }
 
 void
@@ -1518,17 +1547,22 @@
     NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_RTS_TRIGGER,
                     "SetMuRtsRuAllocation() can only be used for MU-RTS");
     NS_ABORT_MSG_IF(
-        value < 61 || value > 68,
+        value < 61 || value > 69,
         "Value "
             << +value
             << " is not admitted for B7-B1 of the RU Allocation subfield of MU-RTS Trigger Frames");
 
     m_ruAllocation = (value << 1);
-    if (value == 68)
+    if (value >= 68)
     {
-        // set B0 for 160 MHz and 80+80 MHz indication
+        // set B0 for 160 MHz, 80+80 MHz and 320 MHz indication
         m_ruAllocation++;
     }
+    if (value == 69)
+    {
+        // set 160 for 320 MHz indication
+        m_ps160 = true;
+    }
 }
 
 uint8_t
@@ -1538,7 +1572,7 @@
                     "GetMuRtsRuAllocation() can only be used for MU-RTS");
     uint8_t value = (m_ruAllocation >> 1);
     NS_ABORT_MSG_IF(
-        value < 61 || value > 68,
+        value < 61 || value > 69,
         "Value "
             << +value
             << " is not admitted for B7-B1 of the RU Allocation subfield of MU-RTS Trigger Frames");
@@ -1727,6 +1761,176 @@
     return m_muBarTriggerDependentUserInfo;
 }
 
+/*****************************************
+ * Trigger frame - Special User Info field
+ *****************************************/
+
+CtrlTriggerSpecialUserInfoField::CtrlTriggerSpecialUserInfoField(TriggerFrameType triggerType)
+    : m_triggerType(triggerType)
+{
+}
+
+CtrlTriggerSpecialUserInfoField&
+CtrlTriggerSpecialUserInfoField::operator=(const CtrlTriggerSpecialUserInfoField& other)
+{
+    // check for self-assignment
+    if (&other == this)
+    {
+        return *this;
+    }
+
+    m_triggerType = other.m_triggerType;
+    m_ulBwExt = other.m_ulBwExt;
+    m_muBarTriggerDependentUserInfo = other.m_muBarTriggerDependentUserInfo;
+
+    return *this;
+}
+
+uint32_t
+CtrlTriggerSpecialUserInfoField::GetSerializedSize() const
+{
+    uint32_t size = 0;
+    size += 5; // User Info (excluding Trigger Dependent User Info)
+
+    switch (m_triggerType)
+    {
+    case TriggerFrameType::BASIC_TRIGGER:
+    case TriggerFrameType::BFRP_TRIGGER:
+        size += 1;
+        break;
+    case TriggerFrameType::MU_BAR_TRIGGER:
+        size +=
+            m_muBarTriggerDependentUserInfo.GetSerializedSize(); // BAR Control and BAR Information
+        break;
+    default:;
+        // The Trigger Dependent User Info subfield is not present in the other variants
+    }
+
+    return size;
+}
+
+Buffer::Iterator
+CtrlTriggerSpecialUserInfoField::Serialize(Buffer::Iterator start) const
+{
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
+                    "BFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER,
+                    "GCR-MU-BAR Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
+                    "NFRP Trigger frame is not supported");
+
+    Buffer::Iterator i = start;
+
+    uint32_t userInfo = 0;
+    userInfo |= (AID_SPECIAL_USER & 0x0fff);
+    userInfo |= (static_cast<uint32_t>(m_ulBwExt) << 15);
+    i.WriteHtolsbU32(userInfo);
+    i.WriteU8(0);
+    // TODO: EHT Spatial Reuse and U-SIG Disregard And Validate
+
+    if (m_triggerType == TriggerFrameType::BASIC_TRIGGER)
+    {
+        // The length is one octet and all the subfields are reserved in a Basic Trigger frame and
+        // in a BFRP Trigger frame
+        i.WriteU8(0);
+    }
+    else if (m_triggerType == TriggerFrameType::MU_BAR_TRIGGER)
+    {
+        m_muBarTriggerDependentUserInfo.Serialize(i);
+        i.Next(m_muBarTriggerDependentUserInfo.GetSerializedSize());
+    }
+
+    return i;
+}
+
+Buffer::Iterator
+CtrlTriggerSpecialUserInfoField::Deserialize(Buffer::Iterator start)
+{
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::BFRP_TRIGGER,
+                    "BFRP Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::GCR_MU_BAR_TRIGGER,
+                    "GCR-MU-BAR Trigger frame is not supported");
+    NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
+                    "NFRP Trigger frame is not supported");
+
+    Buffer::Iterator i = start;
+
+    const auto userInfo = i.ReadLsbtohU32();
+    i.ReadU8();
+    // TODO: EHT Spatial Reuse and U-SIG Disregard And Validate
+
+    const uint16_t aid12 = userInfo & 0x0fff;
+    NS_ABORT_MSG_IF(aid12 != AID_SPECIAL_USER, "Failed to deserialize Special User Info field");
+    m_ulBwExt = (userInfo >> 15) & 0x03;
+
+    if (m_triggerType == TriggerFrameType::BASIC_TRIGGER)
+    {
+        i.ReadU8();
+    }
+    else if (m_triggerType == TriggerFrameType::MU_BAR_TRIGGER)
+    {
+        const auto len = m_muBarTriggerDependentUserInfo.Deserialize(i);
+        i.Next(len);
+    }
+
+    return i;
+}
+
+TriggerFrameType
+CtrlTriggerSpecialUserInfoField::GetType() const
+{
+    return m_triggerType;
+}
+
+void
+CtrlTriggerSpecialUserInfoField::SetUlBwExt(MHz_u bw)
+{
+    switch (static_cast<uint16_t>(bw))
+    {
+    case 20:
+    case 40:
+    case 80:
+        m_ulBwExt = 0;
+        break;
+    case 160:
+        m_ulBwExt = 1;
+        break;
+    case 320:
+        m_ulBwExt = 2;
+        // TODO: differentiate channelization 1 from channelization 2
+        break;
+    default:
+        NS_FATAL_ERROR("Bandwidth value not allowed.");
+        break;
+    }
+}
+
+uint8_t
+CtrlTriggerSpecialUserInfoField::GetUlBwExt() const
+{
+    return m_ulBwExt;
+}
+
+void
+CtrlTriggerSpecialUserInfoField::SetMuBarTriggerDepUserInfo(const CtrlBAckRequestHeader& bar)
+{
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_BAR_TRIGGER,
+                    "Not a MU-BAR Trigger frame");
+    NS_ABORT_MSG_IF(bar.GetType().m_variant != BlockAckReqType::COMPRESSED &&
+                        bar.GetType().m_variant != BlockAckReqType::MULTI_TID,
+                    "BAR Control indicates it is neither the Compressed nor the Multi-TID variant");
+    m_muBarTriggerDependentUserInfo = bar;
+}
+
+const CtrlBAckRequestHeader&
+CtrlTriggerSpecialUserInfoField::GetMuBarTriggerDepUserInfo() const
+{
+    NS_ABORT_MSG_IF(m_triggerType != TriggerFrameType::MU_BAR_TRIGGER,
+                    "Not a MU-BAR Trigger frame");
+
+    return m_muBarTriggerDependentUserInfo;
+}
+
 /***********************************
  *       Trigger frame
  ***********************************/
@@ -1750,6 +1954,7 @@
 CtrlTriggerHeader::CtrlTriggerHeader(TriggerFrameType type, const WifiTxVector& txVector)
     : CtrlTriggerHeader()
 {
+    m_triggerType = type;
     NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::MU_RTS_TRIGGER,
                     "This constructor cannot be used for MU-RTS");
 
@@ -1766,7 +1971,13 @@
                      << txVector.GetPreambleType());
     }
 
-    m_triggerType = type;
+    // special user is always present if solicited TB PPDU format is EHT or later
+    if (txVector.GetModulationClass() >= WifiModulationClass::WIFI_MOD_CLASS_EHT)
+    {
+        NS_ASSERT(m_variant == TriggerFrameVariant::EHT);
+        m_specialUserInfoField.emplace(m_triggerType);
+    }
+
     SetUlBandwidth(txVector.GetChannelWidth());
     SetUlLength(txVector.GetLength());
     const auto gi = txVector.GetGuardInterval().GetNanoSeconds();
@@ -1778,6 +1989,7 @@
     {
         m_giAndLtfType = 2;
     }
+
     for (auto& userInfo : txVector.GetHeMuUserInfoMap())
     {
         CtrlTriggerUserInfoField& ui = AddUserInfoField();
@@ -1811,6 +2023,8 @@
     m_apTxPower = trigger.m_apTxPower;
     m_ulSpatialReuse = trigger.m_ulSpatialReuse;
     m_padding = trigger.m_padding;
+    m_specialUserInfoField.reset();
+    m_specialUserInfoField = trigger.m_specialUserInfoField;
     m_userInfoFields.clear();
     m_userInfoFields = trigger.m_userInfoFields;
     return *this;
@@ -1850,6 +2064,11 @@
     NS_ABORT_MSG_IF(!m_userInfoFields.empty(),
                     "Cannot change Common Info field variant if User Info fields are present");
     m_variant = variant;
+    // special user is always present if User Info field variant is EHT or later
+    if (!m_specialUserInfoField && (m_variant >= TriggerFrameVariant::EHT))
+    {
+        m_specialUserInfoField.emplace(m_triggerType);
+    }
 }
 
 TriggerFrameVariant
@@ -1870,6 +2089,12 @@
         size += 4;
     }
 
+    if (m_specialUserInfoField)
+    {
+        NS_ASSERT(m_variant == TriggerFrameVariant::EHT);
+        size += m_specialUserInfoField->GetSerializedSize();
+    }
+
     for (auto& ui : m_userInfoFields)
     {
         size += ui.GetSerializedSize();
@@ -1909,6 +2134,12 @@
 
     i.WriteHtolsbU64(commonInfo);
 
+    if (m_specialUserInfoField)
+    {
+        NS_ASSERT(m_variant == TriggerFrameVariant::EHT);
+        i = m_specialUserInfoField->Serialize(i);
+    }
+
     for (auto& ui : m_userInfoFields)
     {
         i = ui.Serialize(i);
@@ -1947,6 +2178,18 @@
     NS_ABORT_MSG_IF(m_triggerType == TriggerFrameType::NFRP_TRIGGER,
                     "NFRP Trigger frame is not supported");
 
+    if (m_variant == TriggerFrameVariant::EHT)
+    {
+        m_specialUserInfoField.reset();
+        const auto userInfo = i.ReadLsbtohU16();
+        i.Prev(2);
+        if (const auto aid12 = userInfo & 0x0fff; aid12 == AID_SPECIAL_USER)
+        {
+            m_specialUserInfoField.emplace(m_triggerType);
+            i = m_specialUserInfoField->Deserialize(i);
+        }
+    }
+
     while (i.GetRemainingSize() >= 2)
     {
         // read the first 2 bytes to check if we encountered the Padding field
@@ -2125,17 +2368,35 @@
         m_ulBandwidth = 2;
         break;
     case 160:
+    case 320:
         m_ulBandwidth = 3;
         break;
     default:
         NS_FATAL_ERROR("Bandwidth value not allowed.");
         break;
     }
+    if (bw > MHz_u{160})
+    {
+        NS_ASSERT(m_specialUserInfoField);
+    }
+    if (m_specialUserInfoField)
+    {
+        NS_ASSERT(m_variant == TriggerFrameVariant::EHT);
+        m_specialUserInfoField->SetUlBwExt(bw);
+    }
 }
 
 MHz_u
 CtrlTriggerHeader::GetUlBandwidth() const
 {
+    if (m_specialUserInfoField)
+    {
+        NS_ASSERT(m_variant == TriggerFrameVariant::EHT);
+        if (m_specialUserInfoField->GetUlBwExt() > 1)
+        {
+            return MHz_u{320};
+        }
+    }
     return (1 << m_ulBandwidth) * MHz_u{20};
 }
 
@@ -2243,8 +2504,10 @@
 CtrlTriggerHeader
 CtrlTriggerHeader::GetCommonInfoField() const
 {
-    // make a copy of this Trigger Frame and remove the User Info fields from the copy
+    // make a copy of this Trigger Frame and remove the User Info fields (including the Special User
+    // Info field) from the copy
     CtrlTriggerHeader trigger(*this);
+    trigger.m_specialUserInfoField.reset();
     trigger.m_userInfoFields.clear();
     return trigger;
 }
@@ -2352,11 +2615,10 @@
 
     // check that allocated RUs do not overlap
     // TODO This is not a problem in case of UL MU-MIMO
-    std::vector<HeRu::RuSpec> prevRus;
-
+    std::vector<WifiRu::RuSpec> prevRus;
     for (auto& ui : m_userInfoFields)
     {
-        if (HeRu::DoesOverlap(GetUlBandwidth(), ui.GetRuAllocation(), prevRus))
+        if (WifiRu::DoesOverlap(GetUlBandwidth(), ui.GetRuAllocation(), prevRus))
         {
             return false;
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ctrl-headers.h ns-3.45/src/wifi/model/ctrl-headers.h
--- ns-3.44/src/wifi/model/ctrl-headers.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/ctrl-headers.h	2025-06-01 20:34:45.612702100 -0700
@@ -11,12 +11,13 @@
 
 #include "block-ack-type.h"
 #include "wifi-phy-common.h"
+#include "wifi-ru.h"
 
-#include "ns3/he-ru.h"
 #include "ns3/header.h"
 #include "ns3/mac48-address.h"
 
 #include <list>
+#include <optional>
 #include <vector>
 
 namespace ns3
@@ -674,14 +675,14 @@
      *
      * @param ru the RU this User Info field is allocating
      */
-    void SetRuAllocation(HeRu::RuSpec ru);
+    void SetRuAllocation(WifiRu::RuSpec ru);
     /**
      * Get the RU specified by the RU Allocation subfield.
      * This method cannot be called on MU-RTS Trigger Frames (call GetMuRtsRuAllocation instead).
      *
      * @return the RU this User Info field is allocating
      */
-    HeRu::RuSpec GetRuAllocation() const;
+    WifiRu::RuSpec GetRuAllocation() const;
     /**
      * Set the RU Allocation subfield based on the given value for the B7-B1 bits.
      * This method can only be called on MU-RTS Trigger Frames.
@@ -912,6 +913,107 @@
 
 /**
  * @ingroup wifi
+ * @brief Special User Info field of Trigger frames.
+ *
+ * Trigger frames have been extended by 802.11be amendment and may include one Special User Info
+ * field for a solicited EHT TB PPDU (see Section 9.3.1.22.3 of D7.0). The Special User Info field
+ * is located immediately after the Common Info field, it does not carry user specific information
+ * but carries extended common information not provided in the Common Info field.
+ */
+class CtrlTriggerSpecialUserInfoField
+{
+  public:
+    /**
+     * Constructor
+     *
+     * @param triggerType the Trigger frame type
+     */
+    explicit CtrlTriggerSpecialUserInfoField(TriggerFrameType triggerType);
+
+    /**
+     * Copy assignment operator.
+     *
+     * @param other the Special User Info field to copy
+     * @return a reference to the copied object
+     *
+     * Checks that the given Special User Info fields is included in the same type of Trigger Frame.
+     */
+    CtrlTriggerSpecialUserInfoField& operator=(const CtrlTriggerSpecialUserInfoField& other);
+
+    /**
+     * Get the expected size of this Special User Info field
+     *
+     * @return the expected size of this Special User Info field.
+     */
+    uint32_t GetSerializedSize() const;
+
+    /**
+     * Serialize the Special User Info field to the given buffer.
+     *
+     * @param start an iterator which points to where the header should
+     *        be written
+     * @return Buffer::Iterator to the next available buffer
+     */
+    Buffer::Iterator Serialize(Buffer::Iterator start) const;
+
+    /**
+     * Deserialize the Special User Info field from the given buffer.
+     *
+     * @param start an iterator which points to where the header should
+     *        read from
+     * @return Buffer::Iterator to the next available buffer
+     */
+    Buffer::Iterator Deserialize(Buffer::Iterator start);
+
+    /**
+     * Get the type of the Trigger Frame this Special User Info field belongs to.
+     *
+     * @return the type of the Trigger Frame this Special User Info field belongs to
+     */
+    TriggerFrameType GetType() const;
+
+    /**
+     * Set the UL Bandwidth Extension subfield value of the solicited EHT TB PPDU.
+     *
+     * @param bw bandwidth (allowed values: 20 MHz, 40 MHz, 80 MHz, 160 MHz, 320 MHz)
+     */
+    void SetUlBwExt(MHz_u bw);
+
+    /**
+     * Get the UL Bandwidth Extension subfield value of the solicited EHT TB PPDU.
+     *
+     * @return the UL Bandwidth Extension subfield value
+     */
+    uint8_t GetUlBwExt() const;
+
+    /**
+     * Set the Trigger Dependent Special User Info subfield for the MU-BAR variant of Trigger
+     * frames, which includes the BAR Type subfield. The BAR Type subfield must indicate a
+     * Compressed BAR in an MU BAR Trigger frame.
+     *
+     * @param bar the BlockAckRequest header object including the BAR Control
+     *            subfield and the BAR Information subfield
+     */
+    void SetMuBarTriggerDepUserInfo(const CtrlBAckRequestHeader& bar);
+
+    /**
+     * Get the Trigger Dependent Special User Info subfield for the MU-BAR variant of
+     * Trigger frames, which includes a BAR Type subfield.
+     *
+     * @return the BlockAckRequest header object including the BAR Control
+     *         subfield and the BAR Information subfield
+     */
+    const CtrlBAckRequestHeader& GetMuBarTriggerDepUserInfo() const;
+
+  private:
+    TriggerFrameType m_triggerType{};                        //!< Trigger type
+    uint8_t m_ulBwExt{};                                     //!< UL Bandwidth Extension
+    CtrlBAckRequestHeader m_muBarTriggerDependentUserInfo{}; //!< MU-BAR variant of Trigger
+                                                             //!< Dependent User Info subfield
+};
+
+/**
+ * @ingroup wifi
  * @brief Headers for Trigger frames.
  *
  * 802.11ax amendment defines eight types of Trigger frames (see Section 9.3.1.23 of D3.0):
@@ -1116,15 +1218,15 @@
      */
     bool GetCsRequired() const;
     /**
-     * Set the bandwidth of the solicited HE TB PPDU.
+     * Set the bandwidth of the solicited HE/EHT TB PPDU.
      *
-     * @param bw bandwidth (allowed values: 20, 40, 80, 160)
+     * @param bw bandwidth (allowed values: 20, 40, 80, 160, 320)
      */
     void SetUlBandwidth(MHz_u bw);
     /**
-     * Get the bandwidth of the solicited HE TB PPDU.
+     * Get the bandwidth of the solicited HE/EHT TB PPDU.
      *
-     * @return the bandwidth (20, 40, 80 or 160)
+     * @return the bandwidth (20, 40, 80, 160 or 320)
      */
     MHz_u GetUlBandwidth() const;
     /**
@@ -1139,15 +1241,15 @@
      */
     void SetGiAndLtfType(Time guardInterval, uint8_t ltfType);
     /**
-     * Get the guard interval duration of the solicited HE TB PPDU.
+     * Get the guard interval duration of the solicited HE/EHT TB PPDU.
      *
-     * @return the guard interval duration  of the solicited HE TB PPDU
+     * @return the guard interval duration of the solicited HE/EHT TB PPDU
      */
     Time GetGuardInterval() const;
     /**
-     * Get the LTF type of the solicited HE TB PPDU.
+     * Get the LTF type of the solicited HE/EHT TB PPDU.
      *
-     * @return the LTF type of the solicited HE TB PPDU
+     * @return the LTF type of the solicited HE/EHT TB PPDU
      */
     uint8_t GetLtfType() const;
     /**
@@ -1339,6 +1441,9 @@
     uint16_t m_ulSpatialReuse;      //!< Value for the Spatial Reuse field in HE-SIG-A
     std::size_t m_padding;          //!< the size in bytes of the Padding field
 
+    std::optional<CtrlTriggerSpecialUserInfoField>
+        m_specialUserInfoField; //!< Special User Info field (EHT variant only)
+
     /**
      * List of User Info fields
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/edca-parameter-set.cc ns-3.45/src/wifi/model/edca-parameter-set.cc
--- ns-3.44/src/wifi/model/edca-parameter-set.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/edca-parameter-set.cc	2025-06-01 20:34:45.612702100 -0700
@@ -303,4 +303,12 @@
     return length;
 }
 
+void
+EdcaParameterSet::Print(std::ostream& os) const
+{
+    os << "EDCA Parameter Set=["
+       << "QosInfo: " << +m_qosInfo << ", AC_BE: " << m_acBE << ", AC_BK: " << m_acBK
+       << ", AC_VI: " << m_acVI << ", AC_VO: " << m_acVO << "]";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/edca-parameter-set.h ns-3.45/src/wifi/model/edca-parameter-set.h
--- ns-3.44/src/wifi/model/edca-parameter-set.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/edca-parameter-set.h	2025-06-01 20:34:45.612702100 -0700
@@ -18,7 +18,7 @@
  * @brief The EDCA Parameter Set
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the EDCA Parameter Set.
+ * This class knows how to serialize and deserialize the EDCA Parameter Set.
  */
 class EdcaParameterSet : public WifiInformationElement
 {
@@ -262,6 +262,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     uint8_t m_qosInfo;  ///< QOS info
     uint8_t m_reserved; ///< reserved
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/advanced-ap-emlsr-manager.cc ns-3.45/src/wifi/model/eht/advanced-ap-emlsr-manager.cc
--- ns-3.44/src/wifi/model/eht/advanced-ap-emlsr-manager.cc	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/advanced-ap-emlsr-manager.cc	2025-06-01 20:34:45.612702100 -0700
@@ -60,6 +60,14 @@
                           "another link.",
                           BooleanValue(true),
                           MakeBooleanAccessor(&AdvancedApEmlsrManager::m_updateCwAfterFailedIcf),
+                          MakeBooleanChecker())
+            .AddAttribute("ReportFailedIcf",
+                          "Whether the AP MLD shall report an ICF failure to the remote station "
+                          "manager when all the clients solicited by the MU-RTS are EMLSR "
+                          "clients that have sent (or are sending) a frame to the AP on "
+                          "another link.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&AdvancedApEmlsrManager::m_reportFailedIcf),
                           MakeBooleanChecker());
     return tid;
 }
@@ -191,9 +199,15 @@
 }
 
 bool
-AdvancedApEmlsrManager::UpdateCwAfterFailedIcf()
+AdvancedApEmlsrManager::UpdateCwAfterFailedIcf() const
 {
     return m_updateCwAfterFailedIcf;
 }
 
+bool
+AdvancedApEmlsrManager::ReportFailedIcf() const
+{
+    return m_reportFailedIcf;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/eht/advanced-ap-emlsr-manager.h ns-3.45/src/wifi/model/eht/advanced-ap-emlsr-manager.h
--- ns-3.44/src/wifi/model/eht/advanced-ap-emlsr-manager.h	2025-03-09 16:55:49.783372600 -0700
+++ ns-3.45/src/wifi/model/eht/advanced-ap-emlsr-manager.h	2025-06-01 20:34:45.612702100 -0700
@@ -45,7 +45,8 @@
     Time GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
                                      const WifiTxVector& txVector,
                                      WifiPhyBand band) override;
-    bool UpdateCwAfterFailedIcf() override;
+    bool UpdateCwAfterFailedIcf() const override;
+    bool ReportFailedIcf() const override;
 
   protected:
     void DoDispose() override;
@@ -79,6 +80,9 @@
     bool m_updateCwAfterFailedIcf;      //!< Whether the AP MLD shall double the CW upon CTS timeout
                                    //!< after an MU-RTS in case all the clients solicited by the
                                    //!< MU-RTS are EMLSR clients that have sent a frame to the AP
+    bool m_reportFailedIcf; //!< Whether the AP MLD shall report an ICF failure to the remote
+                            //!< station manager when all the clients solicited by the MU-RTS
+                            //!< are EMLSR clients that have sent a frame to the AP
 };
 
 } // namespace ns3
